library ieee;
use ieee.std_logic_1164.all;

entity sequential_logic_processes is
    port (
        clock: in std_ulogic;
        q: out std_ulogic
    );
end;

architecture with_sensitivity_list of sequential_logic_processes is
begin
    process (clock) begin
        if rising_edge(clock) then
            q <= not q;
        end if;
    end process;
end;

architecture with_wait_statement of sequential_logic_processes is
begin
    process begin
        wait until rising_edge(clock);
        q <= not q;
    end process;
end;