library ieee;
use ieee.std_logic_1164.all;

entity combinational_logic_processes is
    port (
        d1: in std_ulogic;
        d2: in std_ulogic;
        d3: in std_ulogic;
        q: out std_ulogic_vector(1 downto 0)
    );
end;

architecture before_vhdl_2008 of combinational_logic_processes is
begin
    process (d1, d2, d3)
    begin
        if d3 = '1' then
            q <= "11";
        elsif d2 = '1' then
            q <= "10";
        elsif d1 = '1' then
            q <= "01";
        else
            q <= "00";
        end if;
    end process;
end;

architecture after_vhdl_2008 of combinational_logic_processes is
begin
    process (all)
    begin
        if d3 then
            q <= "11";
        elsif d2 then
            q <= "10";
        elsif d1 then
            q <= "01";
        else
            q <= "00";
        end if;
    end process;
end;