entity signal_assignments is
    port (
        value: in natural;
        value_1: in natural;
        value_2: in natural;
        default_value: in natural;
        condition_1: in boolean;
        condition_2: in boolean;
        expression: in natural;
        target: out natural
    );
end;

architecture simple_assignment of signal_assignments is
begin
    target <= value;
end;

architecture conditional_assignment of signal_assignments is
begin
    target <=
      value_1 when condition_1 else
      value_2 when condition_2 else
      default_value;
end;

architecture selected_assignment of signal_assignments is
    constant choice_1: natural := 1;
    constant choice_2: natural := 2;
begin
    with expression select
      target <=
        value_1 when choice_1,
        value_2 when choice_2,
        default_value when others;
end;

