package subprograms_pkg is
    function sum(vect: integer_vector) return integer;
    procedure find_max_min(vect: integer_vector; max, min: out integer);
end;

package body subprograms_pkg is
    function sum(vect: integer_vector)
        return integer
    is
        variable total: integer;
    begin
        total := 0;
        for i in vect'range loop
            total := total + vect(i);
        end loop;
        return total;
    end;

    procedure find_max_min(
        vect: integer_vector;
        max, min: out integer) is
    begin
        max := vect(vect'left);
        min := vect(vect'left);
        for i in vect'range loop
            max := vect(i) when vect(i) > max;
            min := vect(i) when vect(i) < min;
        end loop;
    end;

    procedure usage_example is
        constant fibonacci_seq: integer_vector := (0, 1, 1, 2, 3, 5, 8, 13);
        variable max, min, total: integer;
    begin

        -- A function call; the return value 33 is assigned to variable 'total'
        total := sum(fibonacci_seq);

        -- A procedure call; the output parameters 'max' and 'min' are
        -- overwritten with 13 and 0
        find_max_min(fibonacci_seq, max, min);

    end;
end;