library ieee;
use ieee.std_logic_1164.all;

entity array_type is
    port (
        clk: in std_logic;
        rst: in std_logic
    );
end;

architecture example of array_type  is
    -- Declare an array type for a register file. The number of registers
    -- and the word width can be set later, when an object of the type is created.
    type register_file_type is array (natural range <>) of std_logic_vector;

    -- Declare a register file with 16 registers of 32 bits each.
    signal register_file: register_file_type(0 to 15)(31 downto 0);
begin
    -- Clear the first register of the register file.
    register_file(0) <= x"0000_0000";
end;