library ieee;
use ieee.std_logic_1164.all;

entity attributes is
    port (
        clock: in std_logic;
        vector: in integer_vector(0 to 7);
        max_out: out integer
    );
end;

architecture rtl of attributes is
begin

    find_max: process (clock)
        variable max: integer;
    begin
        -- clock'event is true if clock value has changed in current simulation cycle
        if clock'event and clock = '1' then
            -- vector'left is the index of the leftmost element in the array
            max := vector(vector'left);
            -- vector'range returns the range of an array type or array object
            for i in vector'range loop
                if vector(i) > max then
                    max := vector(i);
                end if;
            end loop;
        end if;
        max_out <= max;
    end process;

end;