-- A 'package declaration' groups
-- declarations (types, constants,
-- subprograms, etc.) that can be
-- reused across modules or designs.
package point_pkg is
    type point is record
        x, y: integer;
    end record;

    function "+"(left, right: point)
        return point;
end;

-- A 'package body' specifies the
-- implementation of subprograms
-- introduced in a package declaration.
package body point_pkg is
    function "+"(left, right: point)
        return point is
    begin
        return (
            left.x + right.x,
            left.y + left.y
        );
    end;
end;