library ieee;
use ieee.std_logic_1164.all;

entity pseudo_random_bit_generator is
    generic (
        SEED: bit_vector(1 to 4) := "1011"
    );
    port (
        clock: in std_ulogic;
        reset: in std_ulogic;
        random_out: out bit
    );
end;

architecture rtl of pseudo_random_bit_generator is
    signal lfsr_state: bit_vector(1 to 4);
begin

    process (clock, reset)
        variable lfsr_input: bit;
    begin
        if reset then
            lfsr_state <= SEED;
        elsif rising_edge(clock) then
            lfsr_input := lfsr_state(3) xor lfsr_state(4) ;
            lfsr_state <= lfsr_input & lfsr_state(1 to 3) ;
        end if;
    end process;

    random_out <= lfsr_state(4);
end;