entity edge_detector is
    port (
        clock: in bit;
        in_pulse: in bit;
        edge_detected: out bit
    );
end;

architecture structural of edge_detector is

    signal in_pulse_delayed: bit;

begin

    delay_dff: entity work.dff
        port map (
            clock => clock,
            d => in_pulse,
            q => in_pulse_delayed
        );

    gate: entity work.xor_gate
        port map (
            a => in_pulse,
            b => in_pulse_delayed,
            y => edge_detected
        );

end;