library ieee;
use ieee.std_logic_1164.all;

entity drivers is
end;

architecture examples of drivers is
    signal a, w, x, y, z: std_ulogic;
    signal b: std_logic;
    signal select_1, select_2, select_3: boolean;
begin
    p1: process (all) begin
        -- Assignment to 'a' implies one driver:
        a <= '0';
        -- Second assignment to 'a' reuses previous driver:
        a <= w when select_1;
        -- Assignment to 'b' implies one driver:
        b <= x when select_1 else 'Z';
    end process;

    p2: process (all) begin
        -- Assignment to 'b' in a different process implies another driver
        -- for the same signal; signal must be resolved.
        b <= y when select_2 else 'Z';
    end process;

    -- Concurrent assignment implies a 3rd driver for 'b':
    b <= z when select_3 else 'Z';
end;
