package rgb_color_type_pkg is
    type rgb_color_type is record
        red, green, blue: integer range 0 to 255;
    end record;

    -- A record aggregate using positional association:
    constant OXFORD_BLUE: rgb_color_type := (6, 13, 69);

    -- A record aggregate using named association:
    constant AQUAMARINE: rgb_color_type := (red => 97, green => 232, blue => 164);

    -- A record aggregate using only the keyword others:
    constant BLACK: rgb_color_type := (others => 0);

    -- A record aggregate using named association and the keyword others:
    constant NAVY_BLUE: rgb_color_type := (blue => 128, others => 0);

    -- Mixed named and positional associations
    -- (this is valid only for record aggregates, not for array aggregates):
    constant SCARLET: rgb_color_type := (255, green => 33, others => 164);
end;