entity function_call_as_slice_prefix is
end;

architecture example of function_call_as_slice_prefix is

    -- Return an integer vector with N elements, all set to 1.
    -- Ex: ones(3) --> (1, 1, 1)
    function ones(N: integer) return integer_vector is begin
        return (1 to N => 1);
    end;

    -- Create a vector with (1, 1, 1, 1):
    constant four_ones: integer_vector(1 to 4) := ones(4);

    -- Create a vector with (1, 1, 1, 1), and then take a
    -- 3-element slice from that vector:
    constant three_ones: integer_vector(1 to 3) := ones(4)(1 to 3);

    -- Result:
    --   four_ones = (1, 1, 1, 1)
    --   three_ones = (1, 1, 1)

begin
end;