library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity cpu_aliases is
end;

architecture rtl of cpu_aliases is

    -- The original name can be an indexed or slice name. In this case, it can be used
    -- for convenience and also to document the meaning behind a specific bit or field.
    signal alu_result: unsigned(31 downto 0);
    alias sign_bit is alu_result(31);

    -- Break down an instruction into its four basic fields:
    signal instruction: std_ulogic_vector(31 downto 0);
    alias opcode is instruction(31 downto 26);
    alias register_s is instruction(25 downto 21);
    alias register_t is instruction(20 downto 16);
    alias immediate is instruction(15 downto 0);

begin
end;