library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity type_casting is
end;

architecture example of type_casting is
begin

    process
        variable value_uns: unsigned(31 downto 0) := x"1111_0000";
        variable value_sig: signed(31 downto 0) := x"1111_0000";
        variable value_slv: std_logic_vector(31 downto 0) := x"1111_0000";
    begin
        -- value_slv := value_sig;                -- Error, different types (slv := signed)
        value_slv := std_logic_vector(value_sig); -- Ok, type casting between closely related types

        -- value_slv := value_uns;                -- Error, different types (slv := unsigned)
        value_slv := std_logic_vector(value_uns); -- Ok, type casting between closely related types

        -- value_uns := value_sig;                -- Error, different types (unsigned := signed)
        value_uns := unsigned(value_sig);         -- Ok, type casting between closely related types

        -- value_uns := value_slv;                -- Error, different types (unsigned := slv)
        value_uns := unsigned(value_slv);         -- Ok, type casting between closely related types

        -- value_sig := value_uns;                -- Error, different types (signed := unsigned)
        value_sig := signed(value_uns);           -- Ok, type casting between closely related types

        -- value_sig := value_slv;                -- Error, different types (signed := slv)
        value_sig := signed(value_slv);           -- Ok, type casting between closely related types

        wait;
    end process;

end;