library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity driving_value_example is
    port (
        clock, reset: in std_logic;
        count: out unsigned(3 downto 0)
    );
end;

architecture rtl of driving_value_example is
begin
    process (clock, reset) begin
        if reset = '1' then
            count <= (others => '0');
        elsif rising_edge(clock) then
            --count <= count + 1;              -- Illegal prior to VHDL-2008
            count <= count'driving_value + 1;  -- Legal since VHDL-93
        end if;
    end process;
end;
