use work.print_pkg.all;

-- Instantiated entity containing signal 'result'
entity adder is
end;

architecture behavioral of adder is
    signal result: bit_vector(3 downto 0);
begin
    process begin
        print("Attributes of signal 'result':");
        print(result'simple_name);    --> result
        print(result'path_name);      --> :alu:adder_inst:result
        print(result'instance_name);  --> :alu(behavioral):adder_inst@adder(rtl):result
        print("");
        wait;
    end process;

    gen: for i in result'range generate
        signal generate_object: bit;
    begin
        process begin
            print("Attributes of instance " & to_string(i) & " of signal 'generate_object':");
            print(generate_object'simple_name);    --> generate_object
            print(generate_object'path_name);      --> :alu:adder_inst:gen(i):generate_object
            print(generate_object'instance_name);  --> :alu(behavioral):adder_inst@adder(rtl):gen(i):generate_object
            print("");
            wait;
        end process;
    end generate;

end;

--------------------------------------------------------------------------------

-- Top-level entity where the entity containing signal 'result' is instantiated
entity alu is
end;

architecture behavioral of alu is
begin
    adder_inst: entity work.adder;
end;
