library ieee;
use ieee.std_logic_1164.all;

entity keyword_all_in_sensitivity_list is
    port (
        clock: in std_logic;
        enable: in std_logic;
        d, s, r: in std_logic;
        q, q_bar: buffer std_logic
    );
end;

architecture example of keyword_all_in_sensitivity_list is
begin

    -- A D-type, edge-triggered flip-flop
    process (all) begin
        if rising_edge(clock) then
            q <= d;
        end if;
    end process;

    -- A D-Type latch
    process (all) begin
        if enable then
            q <= d;
        end if;
    end process;

    -- An SR latch
    process (all) begin
        q <= r nor q_bar;
        q_bar <= s nor q;
    end process;

end;