library ieee;
use ieee.std_logic_1164.all;

entity counter_with_sync_reset is
    port (
        clock: in std_logic;
        reset: in std_logic;
        enable: in std_logic;
        load: in std_logic;
        load_value: in integer range 0 to 15;
        count: out integer range 0 to 15
    );
end;

architecture rtl of counter_with_sync_reset is
begin
    process (clock) begin
        if rising_edge(clock) then
            if reset then
                count <= 0;
            elsif load then
                count <= load_value;
            elsif enable then
                count <= count + 1;
            end if;
        end if;
    end process;
end;