use work.adder_pkg.add;
use work.adder_pkg.adder;

entity dual_adder is
    port (
        addend, augend: in integer;
        sum_1, sum_2: out integer
    );
end;

architecture behavior of dual_adder is
begin
    adder_component: entity work.adder port map (addend, augend, sum_1);
    adder_procedure: add(addend, augend, sum_2);
end;

architecture with_sensitivity_list of dual_adder is
begin
    process (addend, augend) begin
        add(addend, augend, sum_2);
    end process;
end;

architecture with_wait_statement of dual_adder is
begin
    process begin
        add(addend, augend, sum_2);
        wait on addend, augend;
    end process;
end;
