library ieee;
use ieee.std_logic_1164.all;
use ieee.float_pkg.all;

entity dsp is
    port (
        x, y: float32;
        clock: in std_logic;
        reset: in std_logic
    );
end;

architecture rtl of dsp is
    signal acc: float32;
begin
    mac_unit: block
        port (a, b: in float32; mac_out: out float32);
        port map (a => x, b => y, mac_out => acc);
        signal multiplier_out: float32;
        signal adder_out: float32;
    begin
        multiplier_out <= a * b;
        adder_out <= multiplier_out + mac_out;
        process (clock, reset) begin
            if reset then
                mac_out <= (others => '0');
            elsif rising_edge(clock) then
                mac_out <= adder_out;
            end if;
        end process;
    end block;
end;