library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity guarded_signal is
end;

architecture example of guarded_signal is
    signal data_bus: std_logic_vector(31 downto 0) bus;
    signal address: unsigned(31 downto 0);
    signal peripheral_1_data_out: std_logic_vector(31 downto 0) bus := x"deadbeef";
    signal peripheral_2_data_out: std_logic_vector(31 downto 0) bus := x"55aa55aa";
begin
    b1: block (x"0000" <= address and address < x"0010") begin
        data_bus <= guarded peripheral_1_data_out;
    end block;

    b2: block (x"0010" <= address and address < x"0020") begin
        data_bus <= guarded peripheral_2_data_out;
    end block;
end;
