entity for_loop_with_dynamic_range is
    generic (
        NUM_ITERATIONS_MAX: integer := 10
    );
    port (
        inputs: in integer_vector(1 to NUM_ITERATIONS_MAX);
        num_iterations: in integer range 0 to NUM_ITERATIONS_MAX;
        sum_with_dynamic_range: out integer;
        sum_with_exit_statement: out integer;
        sum_with_if_statement: out integer
    );
end;

architecture example of for_loop_with_dynamic_range is
begin
    process (inputs, num_iterations) is
        variable sum: integer;
    begin
        sum := 0;
        for i in 1 to num_iterations loop
            sum := sum + inputs(i);
        end loop;
        sum_with_dynamic_range <= sum;
    end process;

    process (inputs, num_iterations) is
        variable sum: integer;
    begin
        sum := 0;
        for i in 1 to NUM_ITERATIONS_MAX loop
            exit when i > num_iterations;
            sum := sum + inputs(i);
        end loop;
        sum_with_exit_statement <= sum;
    end process;

    process (inputs, num_iterations) is
        variable sum: integer;
    begin
        sum := 0;
        for i in 1 to NUM_ITERATIONS_MAX loop
            if i <= num_iterations then
                sum := sum + inputs(i);
            end if;
        end loop;
        sum_with_if_statement <= sum;
    end process;
end;

