library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity sequential_assert_statements is
end;

architecture examples of sequential_assert_statements is
    signal x: integer;
    signal fractional_value: std_logic_vector(7 downto 0);
begin
    process begin
        assert (1 <= x) and (x <= 127);

        assert x > 0 severity error;

        assert x /= 0 report "This should never happen";

        assert fractional_value(4 downto 0) = "00000"
            report "Precision loss - value will be truncated"
            severity warning;

        wait;
    end process;
end;
