library ieee;
use ieee.std_logic_1164.all;
use ieee.float_pkg.all;
use work.exponentiation_pkg.all;

entity quadratic_equation is
    port (
        clock: in std_logic;
        a, b, c: in float32;
        root_1, root_2: out float32
    );
end;

architecture using_variable of quadratic_equation is
begin
    process (clock)
        variable discriminant: float32;
    begin
        if rising_edge(clock) then
            discriminant := b**2 - 4 * a * c;
            root_1 <= (- b + discriminant) / (2 * a);
            root_2 <= (- b - discriminant) / (2 * a);
        end if;
    end process;
end;

architecture using_signal of quadratic_equation is
    signal discriminant: float32;
begin
    process (clock) begin
        if rising_edge(clock) then
            discriminant <= b**2 - 4 * a * c;
            root_1 <= (- b + discriminant) / (2 * a);
            root_2 <= (- b - discriminant) / (2 * a);
        end if;
    end process;
end;