entity counter_increment is
    port (
        current_count: in integer;
        increment: in integer;
        next_count: out integer
    );
end;

architecture concurrent_assignment of counter_increment is
begin
    next_count <= current_count + increment;
end;

architecture process_with_sensitivity_list of counter_increment is
begin
    process (current_count, increment) begin
        next_count <= current_count + increment;
    end process;
end;

architecture process_with_wait_statement of counter_increment is
begin
    process begin
        next_count <= current_count + increment;
        wait on current_count, increment;
    end process;
end;