library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity sequential_assignment_statements is
    port (
        phase: in unsigned(7 downto 0);
        sine_table_address: out unsigned(5 downto 0)
    );
end;

architecture example of sequential_assignment_statements is
    constant LUT_ADDRESS_MAX: unsigned := to_unsigned(63, 6);
begin
    process (phase) is
        variable phase_quadrant: unsigned(1 downto 0);
        variable phase_offset: unsigned(5 downto 0);
        variable quadrant_is_odd: std_logic;
    begin
        (phase_quadrant, phase_offset) := phase;
        quadrant_is_odd := not phase_quadrant(0);

        if quadrant_is_odd then
            sine_table_address <= phase_offset;
        else
            sine_table_address <= LUT_ADDRESS_MAX - phase_offset;
        end if;
    end process;
end;