library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.seven_seg_pkg.all;

entity counter_display_0_to_9 is
    port (
        clock: in std_logic;
        reset: in std_logic;
        seven_seg: out std_logic_vector(6 downto 0)
    );
end;

architecture rtl of counter_display_0_to_9 is
    signal count: unsigned(3 downto 0);
begin

    counter: process (clock, reset) begin
        if reset then
            count <= (others => '0');
        elsif rising_edge(clock) then
            count <= count + 1;
        end if;
    end process;

    display: seven_seg <= seven_seg_from_bcd(count);

end;