library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

package seven_seg_pkg is
    function seven_seg_from_bcd(bcd: unsigned(3 downto 0)) return std_logic_vector;
end;

package body seven_seg_pkg is
    function seven_seg_from_bcd(bcd: unsigned(3 downto 0))
        return std_logic_vector
    is begin
        case bcd is
            --                   abcdefg
            when x"0" => return "0111111";
            when x"1" => return "0000110";
            when x"2" => return "1011011";
            when x"3" => return "1001111";
            when x"4" => return "1100110";
            when x"5" => return "1101101";
            when x"6" => return "1111101";
            when x"7" => return "0000111";
            when x"8" => return "1111111";
            when x"9" => return "1101111";
            when others => return "0000000";
        end case;
    end;
end;
