use std.textio.all;

package enumeration_types_pkg is

    type multivalued_logic_type is ('X', 'Z', 'L', '0', 'H', '1');

    type transmission_mode_type is (park, reverse, neutral, drive, second, low);
    subtype forward_modes_subtype is transmission_mode_type range park to drive;

    type mixed_enumeration_type is ('0', zero, '1', one);

    -- An enumeration type describing the states of an FSM
    type garage_door_state is (opened, closing, closed, opening);

    -- An enumeration type for the operations in an ALU
    type alu_operation_type is (
        op_add, op_subtract, op_increment, op_decrement, op_and, op_or, op_nand, op_nor
    );

    -- An enumeration type for parity configuration in a UART
    type parity_mode_type is (even_parity, odd_parity, no_parity);

    type color_type is (red, orange, yellow, green, cyan, blue, violet);
    type color_to_boolean_type is array (color_type) of boolean;
    constant IS_WARM: color_to_boolean_type := (
        red to yellow => true,
        others => false
    );

    procedure print_warm_colors;
end;

package body enumeration_types_pkg is

    procedure print_warm_colors is
    begin
        for i in color_type loop
            if IS_WARM(i) then
                write(output, "Color is warm: " & to_string(i) & LF);
            end if;
        end loop;
    end;

end;