entity predefined_operations_of_scalar_types is
end;

architecture examples of predefined_operations_of_scalar_types is
    type transmission_mode_type is (park, reverse, neutral, drive, second, low);
    type color_type is (red, orange, yellow, green, cyan, blue, violet);
    type color_array_type is array (natural range <>) of color_type;
    type plank_temperature_type is range 0.0 to 1.416833e32;
    type plank_temperature_array_type is array (natural range <>) of plank_temperature_type;
begin

    process
        variable current_temperature: plank_temperature_type;
        variable higher_frequency_color: color_type;
        variable bool: boolean;
        variable str: string(1 to 7);
    begin
        bool := (red > orange);        --> false
        bool := (neutral <= drive);    --> true
        str := to_string(reverse);     --> "reverse"
        current_temperature := maximum( (1.0, 2.0, 5.0) );   --> 5.0
        higher_frequency_color := maximum( (red, green, blue) );   --> "blue"

        wait;
    end process;

end;
