entity access_type is
end;

architecture examples of access_type is

    procedure integer_allocator_example is
        type integer_pointer_type is access integer;
        variable integer_pointer: integer_pointer_type;
    begin
        -- Allocator using a type name; the new object gets
        -- the default initial value defined by its type:
        integer_pointer := new integer;
        deallocate(integer_pointer);

        -- Allocator using a qualified expression and a literal value:
        integer_pointer := new integer'(5);
        deallocate(integer_pointer);
    end;

    procedure array_allocator_example is
        type integer_vector_pointer_type is access integer_vector;
        variable integer_vector_pointer: integer_vector_pointer_type;
    begin
        -- Create a vector with three integer objects
        integer_vector_pointer := new integer_vector'(1, 2, 3);
        deallocate(integer_vector_pointer);

        -- Create a vector with room for 10 integer objects
        integer_vector_pointer := new integer_vector(1 to 10);
        deallocate(integer_vector_pointer);
    end;

begin

    integer_allocator_example;
    array_allocator_example;

end;