library ieee;
use ieee.std_logic_1164.all;
use work.clock_time_pkg.all;
use work.print_pkg.all;

entity clock_24hr is
    port (
        clock_1_sec: in std_ulogic;
        reset: in std_ulogic;
        seconds_units: out integer range 0 to 9;
        seconds_tens: out integer range 0 to 9;
        minutes_units: out integer range 0 to 9;
        minutes_tens: out integer range 0 to 9;
        hours_units: out integer range 0 to 9;
        hours_tens: out integer range 0 to 9
    );
end;

architecture rtl of clock_24hr is
begin

    process (clock_1_sec, reset)
        variable clock_time: clock_time_type;
    begin
        if reset then
            clock_time.reset;
        elsif rising_edge(clock_1_sec) then
            clock_time.increment;
            print(clock_time.to_string);
            (seconds_units, seconds_tens, minutes_units, minutes_tens,
                hours_units, hours_tens) <= clock_time.digits;
        end if;
    end process;
end;