package mvl4_pkg is
    type mvl4 is ('X', '0', '1', 'Z');
    type mvl4_vector is array (natural range <>) of mvl4;
    function resolved(sources: mvl4_vector) return mvl4;
    subtype mvl4_resolved is resolved mvl4;
    subtype mvl4_resolved_vector is (resolved) mvl4_vector;
end;

package body mvl4_pkg is

    type mvl4_matrix is array (mvl4, mvl4) of mvl4;
    constant RESOLUTION_MATRIX: mvl4_matrix := (
    --   'X'  '0'  '1'  'Z'
        ('X', 'X', 'X', 'X'), -- 'X'
        ('X', '0', 'X', '0'), -- '0'
        ('X', 'X', '1', '1'), -- '1'
        ('X', '0', '1', 'Z')  -- 'Z'
    );

    function resolved(sources: mvl4_vector) return mvl4 is
        variable resolved_value: mvl4 := 'Z';
    begin
        for i in sources'range loop
            resolved_value := RESOLUTION_MATRIX(resolved_value, sources(i));
        end loop;
        return resolved_value;
    end;

end;