entity assignments_between_subtypes is
end;

architecture example of assignments_between_subtypes is
begin

    -- No conversion is necessary when objects belong to subtypes of a common base type
    process
        subtype long_int_type is integer range 0 to 65535;
        subtype short_int_type is integer range 0 to 255;

        variable long_int: long_int_type;
        variable short_int: short_int_type;
    begin

        short_int := 10;

        -- OK, short_int and long_int have the same base type and
        -- the value (10) is within the range of long_int_type:
        long_int := short_int;

        long_int := 10000;

        -- Error: value (10000) is outside the range of short_int_type:
        short_int := long_int;

        wait;
    end process;

end;