library ieee;
use ieee.numeric_std.all;

entity instantiated_entity_with_unsigned_ports is
    port (
        operand_1: in unsigned(7 downto 0);
        operand_2: in unsigned(7 downto 0);
        sum: out unsigned(8 downto 0);
        difference: out unsigned(8 downto 0)
    );
end;

architecture rtl of instantiated_entity_with_unsigned_ports is
begin
    sum <= resize(operand_1, 9) + resize(operand_2, 9);
    difference <= resize(operand_1, 9) - resize(operand_2, 9);
end;

--------------------------------------------------------------------------------
library ieee;
use ieee.numeric_std.all;

entity instantiating_entity_with_natural_ports is
    port (
        operand_1: in natural range 0 to 255;
        operand_2: in natural range 0 to 255;
        difference: out natural range 0 to 511;
        sum: out natural range 0 to 511
    );
end;

architecture rtl of instantiating_entity_with_natural_ports is
begin
    instantiated_inst: entity work.instantiated_entity_with_unsigned_ports
        port map(
            operand_1 => to_unsigned(operand_1, 8),
            operand_2 => to_unsigned(operand_2, 8),
            to_integer(sum) => sum,
            to_integer(difference) => difference
        );
end;
