library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity type_qualification is
end;

architecture example of type_qualification is
begin
    -- VHDL allows us to "reuse" function names, as long as the types of its
    -- arguments or return values are different. This is called "function
    -- overloading". When an overloaded function name is used in the code, the
    -- compiler must decide which version to use. If more than one function are
    -- applicable, it aborts the compilation and reports that the name is ambiguous.
    process
        function distance(left_op, right_op: unsigned) return integer is begin
            return to_integer(unsigned(left_op) + unsigned(right_op));
        end;

        function distance(left_op, right_op: std_logic_vector) return integer is begin
            return to_integer(unsigned(left_op) + unsigned(right_op));
        end;

        variable result: integer;
    begin
        result := distance("1000", "0001");    -- Error: "distance" is ambiguous
        result := distance(std_logic_vector'("0001"), "1000");  -- OK, use 1st version
        result := distance(unsigned'("0001"), "1000");          -- OK, use 2nd version

        wait;
    end process;
end;
