-- Abstract data type for bit matrices and corresponding operations.
package bit_matrix_type_pkg is
    -- Underlying data structure for the ADT
    type bit_matrix_type is array (natural range <>, natural range <>) of bit;

    -- ADT operations
    function "+"(A, B: bit_matrix_type) return bit_matrix_type;
    function "-"(A, B: bit_matrix_type) return bit_matrix_type;
    function "*"(A, B: bit_matrix_type) return bit_matrix_type;
    function identity_matrix(size: integer) return bit_matrix_type;
    procedure fill_with_zeroes(matrix: out bit_matrix_type);
    -- ...
end;

package body bit_matrix_type_pkg is
    function "+"(A, B: bit_matrix_type) return bit_matrix_type is
        variable sum: bit_matrix_type(A'range(1), A'range(2));
    begin
        -- ...
        return sum;
    end;

    function "-"(A, B: bit_matrix_type) return bit_matrix_type is
        variable difference: bit_matrix_type(A'range(1), A'range(2));
    begin
        -- ...
        return difference;
    end;

    function "*"(A, B: bit_matrix_type) return bit_matrix_type is
        variable product: bit_matrix_type(A'range(1), A'range(2));
    begin
        -- ...
        return product;
    end;

    function identity_matrix(size: integer) return bit_matrix_type is
        variable identity: bit_matrix_type(1 to size, 1 to size);
    begin
        -- ...
        return identity;
    end;

    procedure fill_with_zeroes(matrix: out bit_matrix_type) is
    begin
        -- ...
    end;

    -- ...
end;