library ieee;
use ieee.float_pkg.all;

entity removing_code_duplication is
end;

architecture with_duplication of removing_code_duplication is
begin
    process
        variable x_pos, y_pos, z_pos: float32;
        variable x_velocity, y_velocity, z_velocity: float32;
        variable x_acceleration, y_acceleration, z_acceleration: float32;
    begin
        x_pos := to_float(0);
        y_pos := to_float(0);
        z_pos := to_float(0);

        x_velocity := to_float(0);
        y_velocity := to_float(0);
        z_velocity := to_float(0);

        x_pos := x_pos + x_velocity;
        y_pos := y_pos + y_velocity;
        z_pos := z_pos + z_velocity;

        x_velocity := x_velocity + x_acceleration;
        y_velocity := y_velocity + y_acceleration;
        z_velocity := z_velocity + z_acceleration;

        wait;
    end process;
end;

architecture without_duplication of removing_code_duplication is
begin
    process
        type cartesian_axis_type is (x, y, z);
        type point_type is array (cartesian_axis_type) of float32;
        variable pos, velocity, acceleration: point_type;

        function "+"(op_1, op_2: point_type) return point_type is
        begin
            return (op_1(x) + op_2(x), op_1(y) + op_2(y), op_1(z) + op_2(z));
        end;
    begin
        pos := (others => to_float(0));
        velocity := (others => to_float(0));

        pos := pos + velocity;
        velocity := velocity + acceleration;

        wait;
    end process;
end;
