package initialization_constants_pkg is
    type clock_time_type is record hours, minutes, seconds: integer; end record;
    constant TIME_ZERO: clock_time_type := (hours => 0, minutes => 0, seconds => 0);

    type color_type is record red, green, blue: integer; end record;
    constant COLOR_WHITE: color_type := (red => 255, green => 255, blue => 255);

    type screen_position_type is record x, y: integer; end record;
    constant SCREEN_CENTER_POS: screen_position_type := (x => 400, y => 300);

    type real_matrix is array (natural range <>, natural range <>) of real;
    function identity_matrix(size: integer) return real_matrix;
    constant IDENTITY_MATRIX_3x3: real_matrix;
end;

package body initialization_constants_pkg is

    function identity_matrix(size: integer) return real_matrix is
        variable matrix: real_matrix(1 to size, 1 to size);
    begin
        for i in 1 to size loop
            for j in 1 to size loop
                matrix(i, j) := 1.0 when (i = j) else 0.0;
            end loop;
        end loop;

        return matrix;
    end;

    constant IDENTITY_MATRIX_3x3: real_matrix := identity_matrix(3);

end;