library ieee;
use ieee.std_logic_1164.all;

package cpu_stage_pkg is
    type stage_type is (fetch, decode, execute);
    type stage_encoding_type is array (stage_type) of std_logic_vector;
    constant ENCODED_CPU_STATE: stage_encoding_type := (
        fetch => "001", decode => "010", execute => "100"
    );
end;

--------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use work.cpu_stage_pkg.all;

entity book_section_types_guidelines is
    port (
        current_stage: in stage_type;
        cpu_state_register: out std_logic_vector(2 downto 0)
    );
end;

architecture example of book_section_types_guidelines is
begin
    cpu_state_register <= ENCODED_CPU_STATE(current_stage);
end;