package matrix_pkg is
    type matrix_type is array (natural range <>, natural range <>) of bit;
    function identity_matrix(size: integer) return matrix_type;

    -- A deferred constant declaration
    constant IDENTITY_MATRIX_3x3: matrix_type;
end;

package body matrix_pkg is

    function identity_matrix(size: integer) return matrix_type is
        variable matrix: matrix_type(1 to size, 1 to size);
    begin
        for i in 1 to size loop
            for j in 1 to size loop
                matrix(i, j) := '1' when (i = j) else '0';
            end loop;
        end loop;

        return matrix;
    end;

    -- Full constant declaration corresponding to the deferred constant
    constant IDENTITY_MATRIX_3x3: matrix_type := identity_matrix(3);

end;