library ieee;
use ieee.std_logic_1164.all;

entity assignments_from_different_processes is
    port (
        condition_1, condition_2: in boolean
    );
end;

architecture example of assignments_from_different_processes is
    signal single_wire_bus: std_logic;
begin
    single_wire_bus <= 'H'; -- weak pull-up

    process (all) begin
        if condition_1 then
            single_wire_bus <= '0';  -- forcing low
        else
            single_wire_bus <= 'Z';  -- high impedance
        end if;
    end process;

    process (all) begin
        if condition_2 then
            single_wire_bus <= '1';  -- forcing high
        else
            single_wire_bus <= 'Z';  -- high impedance
        end if;
    end process;
end;