library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity div_by_3 is
    port (
        dividend: in unsigned(31 downto 0);
        quotient: out unsigned(31 downto 0)
    );
end;

architecture rtl of div_by_3 is
begin

    process (dividend)
        alias n is dividend;
        variable q, r: unsigned(31 downto 0);
    begin
        q := (n srl 2) + (n srl 4); -- q = n*0.0101 (approx)
        q := q + (q srl 4);         -- q = n*0.01010101
        q := q + (q srl 8);
        q := q + (q srl 16);
        r := resize(n - q * 3, 32);             -- 0 <= r <= 15.
        q := resize(q + (5 * (r + 1) srl 4), 32); -- Alternative 1
        quotient <= q;
    end process;

end;
