library ieee;
use ieee.std_logic_1164.all;

entity file_write_tool_dependent_format is
end;

architecture example of file_write_tool_dependent_format is
begin

    -- Write two records to a file named "stimuli.dat" in a tool-dependent format
    process
        -- A type describing the format of each object in the file
        type file_element_type is record
            object_number: integer;
            stimuli: std_logic_vector(31 downto 0);
        end record;

        -- A type for the file itself
        type stimuli_file_type is file of file_element_type;

        -- An object of class 'file' whose format is given by the two types above
        file stimuli_file: stimuli_file_type open write_mode is "stimuli.dat";
    begin
        -- Write two records to the file
        write(stimuli_file, (1, x"ff00ff00"));
        write(stimuli_file, (2, x"55aa55aa"));

        file_close(stimuli_file);

        wait;
    end process;

end;