library ieee;
use ieee.std_logic_1164.all;
use std.textio.all;

entity file_read_tool_dependent_format is
end;

architecture example of file_read_tool_dependent_format is
begin

    -- Read file "stimuli.dat" and print its contents (file contents are in a tool-dependent format)
    process
        -- A type describing the format of each object in the file
        type file_element_type is record
            object_number: integer;
            stimuli: std_logic_vector(31 downto 0);
        end record;

        -- A type for the file itself
        type stimuli_file_type is file of file_element_type;

        -- An object of class 'file' whose format is given by the two types above
        file stimuli_file: stimuli_file_type open read_mode is "stimuli.dat";

        -- A variable to hold the value of each element read from the file
        variable current_element: file_element_type;
    begin

        while not endfile(stimuli_file) loop
            -- Read a single record from the file
            read(stimuli_file, current_element);

            -- Print the values of the record fields
            write(output,
                to_string(current_element.object_number) & " " &
                to_string(current_element.stimuli) & LF
            );
        end loop;

        file_close(stimuli_file);

        wait;
    end process;

end;