library ieee;
use ieee.std_logic_1164.all;
use std.textio.all;

entity file_read_and_write_in_textual_format is
end;

architecture example of file_read_and_write_in_textual_format is
begin

    -- Write two lines to a file named "ascii_stimuli_out.txt" in text format (human-readable)
    process
        file stimuli_file: text open write_mode is "ascii_stimuli_out.txt";
        variable current_line: line;
    begin

        write(current_line, 1, field => 3, justified => left);
        write(current_line, bit_vector'(x"ff00ff00"));
        writeline(stimuli_file, current_line);

        write(current_line, 2, field => 3, justified => left);
        write(current_line,  bit_vector'(x"55aa55aa"));
        writeline(stimuli_file, current_line);

        file_close(stimuli_file);

        wait;
    end process;

    -- Read all lines from a file named "ascii_stimuli_in.txt" in text format (human-readable)
    process
        file stimuli_file: text open read_mode is "ascii_stimuli_in.txt";
        variable current_line: line;
        variable object_number: integer;
        variable stimuli: std_logic_vector(31 downto 0);
    begin

        while not endfile(stimuli_file) loop
            readline(stimuli_file, current_line);
            read(current_line, object_number);
            read(current_line, stimuli);
            write(output, to_string(object_number) & " " & to_string(stimuli) & LF );
        end loop;

        file_close(stimuli_file);

        wait;
    end process;

end;