library ieee;
use ieee.std_logic_1164.all;
use work.print_pkg.all;
use std.textio.all;

entity initial_values is
end;

architecture examples of initial_values is
begin

    process
        type parity_mode_type is (no_parity, even_parity, odd_parity);
        variable parity_mode: parity_mode_type; -- Initial value is no_parity
        variable carry_bit: std_logic;          -- Initial value is 'U'
        variable syllable: string(1 to 3);      -- Initial value is (nul, nul, nul)
        variable current_line: line;            -- Initial value is null
        variable count: integer;    -- Initial value is the smallest
                                    -- representable integer (e.g., -2147483648)
    begin
        print("Initial value of variable 'parity_mode': " & to_string(parity_mode));

        print("Initial value of variable 'carry_bit': " & to_string(carry_bit));

        print("Initial value of variable 'count': " & to_string(count));

        if syllable = (nul, nul, nul) then
            print("Initial value of variable 'syllable': (nul, nul, nul)");
        else
            print("Initial value of variable 'syllable': " & syllable);
        end if;

        if current_line = null then
            print("Initial value of variable 'current_line': null");
        else
            print("Initial value of variable 'current_line': " & current_line.all);
        end if;

        wait;
    end process;

end;
