library ieee;
use ieee.std_logic_1164.all;
use work.aes_pkg.all;

package routines_example is
end;

package body routines_example is

    procedure big_block_of_code(round_key: state_type) is
        variable state_1, state_2, state_3, state_4: state_type;
    begin
        -- sub bytes
        for i in 0 to 3 loop
            for j in 0 to 3 loop
                state_2(i,j) := sbox(state_1(i,j));
            end loop;
        end loop;

        -- shift rows
        for i in 0 to 3 loop
            for j in 0 to 3 loop
                state_3(i,j) := state_2(i,(j+i) mod 4);
            end loop;
        end loop;

        -- add round key
        for i in 0 to 3 loop
            for j in 0 to 3 loop
                state_4(i,j) := state_3(i,j) xor round_key(i,j);
            end loop;
        end loop;
    end;

    procedure code_organized_into_routines(round_key: state_type) is
        variable state_1, state_2, state_3, state_4: state_type;

        function sub_bytes(state: state_type) return state_type is
            variable updated_state: state_type;
        begin
            -- Code for operation 'sub bytes'
            -- ...
            return updated_state;
        end;

        function shift_rows(state: state_type) return state_type is
            variable updated_state: state_type;
        begin
            -- Code for operation 'shift rows'
            -- ...
            return updated_state;
        end;

        function add_round_key(state: state_type; round_key: state_type) return state_type is
            variable updated_state: state_type;
        begin
            -- Code for operation 'add round key'
            -- ...
            return updated_state;
        end;

    begin
        state_2 := sub_bytes(state_1);
        state_3 := shift_rows(state_2);
        state_4 := add_round_key(state_3, round_key);
    end;

end;

