entity removing_code_duplication_with_functions is
    port (
        x_in, y_in: in bit_vector(9 downto 0);
        x_out, y_out: in bit_vector(9 downto 0);
        x_next, y_next: in bit_vector(9 downto 0);
        write_address, read_address: out bit_vector(15 downto 0);
        next_address: out bit_vector(15 downto 0)
    );
end;

architecture with_duplicated_code of removing_code_duplication_with_functions is
begin
    write_address <= x_in(9 downto 2) & y_in(9 downto 2);
    read_address <= x_out(9 downto 2) & y_out(9 downto 2);
    next_address <= x_next(9 downto 2) & y_next(9 downto 2);
end;

architecture without_duplicated_code of removing_code_duplication_with_functions is
    function address_from_x_y(x, y: in bit_vector) return bit_vector is
    begin
        return x(9 downto 2) & y(9 downto 2);
    end;
begin
    write_address <= address_from_x_y(x_in, y_in);
    read_address <= address_from_x_y(x_out, y_out);
    next_address <= address_from_x_y(x_next, y_next);
end;
