library ieee;
use ieee.std_logic_1164.all;
use work.bcd_7seg_pkg.all;

entity functions_vs_procedures is
end;

architecture using_functions of functions_vs_procedures is
    signal seven_seg: std_logic_vector(13 downto 0);
    signal num_lives_p1: integer range 0 to 9 := 3;
    signal num_lives_p2: integer range 0 to 9 := 3;
begin
    seven_seg <= seven_seg_from_bcd( bcd_from_int( num_lives_p1 ) & bcd_from_int( num_lives_p2 ) );
end;

architecture using_procedures of functions_vs_procedures is
    signal seven_seg: std_logic_vector(13 downto 0);
    signal num_lives_p1: integer range 0 to 9 := 3;
    signal num_lives_p2: integer range 0 to 9 := 3;
    signal num_lives_p1_bcd: std_logic_vector(3 downto 0);
    signal num_lives_p2_bcd: std_logic_vector(3 downto 0);
begin
    convert_int_to_bcd( num_lives_p1, num_lives_p1_bcd );
    convert_int_to_bcd( num_lives_p2, num_lives_p2_bcd );
    convert_bcd_to_seven_seg( num_lives_p1_bcd & num_lives_p2_bcd, seven_seg );
end;

