library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

package unsigned_to_seven_segment_pkg is
end;

package body unsigned_to_seven_segment_pkg is
    -- Return a vector for driving a series of 7-segment displays.
    function unsigned_to_seven_segment(
        value: unsigned;
        number_of_digits: integer;
        -- When true, treat the input value as a BCD number where
        -- every 4 bits hold one digit from 0 to A. When false,
        -- treat the input number as an unsigned integer.
        value_is_bcd: boolean
    ) return std_logic_vector is
        -- ...
        variable segments: std_logic_vector(number_of_digits*7-1 downto 0);
        variable unsigned_digit: unsigned(3 downto 0);
        variable bcd_quotient: unsigned(value'range);
        variable bcd_remainder: unsigned(3 downto 0);
    begin
        if value_is_bcd then
            -- code treating the input value as BCD digits
            -- ...
        else
            -- code treating the input value as an unsigned integer
            -- ...
        end if;

        return segments;
    end;
end;