library ieee;
use ieee.math_real.all;

package sqrt_pkg is
    function sqrt_single_return(x: real) return real;
    function sqrt_multiple_returns(x : real) return real;
end;

package body sqrt_pkg is

    function sqrt_single_return(x: real) return real is
        constant inival: real := 1.5;
        constant eps: real := 0.000001;
        constant relative_error: real := eps * x;
        variable previous_value: real;
        variable new_value: real;
        variable sqrt_value: real := 0.0;
    begin
        if (x < 0.0) then
            assert false report "x < 0 in sqrt(x)" severity error;
            sqrt_value := 0.0;
        else
            if x = 0.0 then
                sqrt_value := 0.0;
            else
                if (x = 1.0) then
                    sqrt_value := 1.0;
                else
                    previous_value := inival;
                    new_value := (x / previous_value + previous_value) / 2.0;

                    while (abs (new_value - previous_value) > relative_error) loop
                        previous_value := new_value;
                        new_value := (x / previous_value + previous_value) / 2.0;
                    end loop;

                    sqrt_value := new_value;
                end if;
            end if;
        end if;

        return sqrt_value;
    end;

    function sqrt_multiple_returns(x : real) return real is
        constant inival: real := 1.5;
        constant eps: real := 0.000001;
        constant relative_err: real := eps * x;
        variable oldval: real;
        variable newval: real;
    begin
        if (x < 0.0) then
            assert false report "x < 0 in sqrt(x)" severity error;
            return (0.0);
        end if;

        if x = 0.0 then
            return 0.0;
        end if;

        if (x = 1.0) then
            return 1.0;
        end if;

        oldval := inival;
        newval := (x / oldval + oldval) / 2.0;
        while (abs (newval - oldval) > relative_err) loop
            oldval := newval;
            newval := (x / oldval + oldval) / 2.0;
        end loop;

        return newval;
    end;

end;