package rectangles_pkg is
end;

package body rectangles_pkg is
    subtype coordinate_type is natural range 0 to 2047;

    function rectangles_intersect(
        rect_1_top, rect_1_left, rect_1_bottom, rect_1_right: coordinate_type;
        rect_2_top, rect_2_left, rect_2_bottom, rect_2_right: coordinate_type
    ) return boolean is
    begin
        return not (
            (rect_1_bottom < rect_2_top) or
            (rect_1_top > rect_2_bottom) or
            (rect_1_left > rect_2_right) or
            (rect_1_right < rect_2_left)
        );
    end;

    type rectangle_type is record
        left, top, right, bottom: coordinate_type;
    end record;

    function rectangles_intersect(rect_1, rect_2: rectangle_type) return boolean is
    begin
        return not (
            (rect_1.bottom < rect_2.top) or
            (rect_1.top > rect_2.bottom) or
            (rect_1.left > rect_2.right) or
            (rect_1.right < rect_2.left)
        );
    end;

end;