library ieee;
use ieee.float_pkg.float32;
use ieee.fixed_float_types.round_type;

entity guidelines is
end;

architecture default_values_float of guidelines is
    function add(
        left_op, right_op: float32;
        constant round_style: round_type := round_nearest;
        constant num_guard_bits: natural := 3;
        constant denormalize: boolean := true
    ) return float32 is
    begin
        return ieee.float_pkg.add(
            left_op,
            right_op,
            round_style => round_style,
            guard => num_guard_bits,
            denormalize => denormalize
        );
    end;

    signal operand_1, operand_2, operand_3: float32;
    signal sum_1, sum_2, sum_3: float32;
begin

    sum_1 <= add(operand_1, operand_2);
    sum_2 <= add(operand_2, operand_3);
    sum_3 <= add(operand_2, operand_3,
        round_style => round_nearest,
        num_guard_bits => 5,
        denormalize => false
    );

end;