library ieee;
use ieee.std_logic_1164.all;

entity avoid_numerals_in_names is
end;

architecture bad_example of avoid_numerals_in_names is
    signal pending_interrupt_0: boolean;
    signal pending_interrupt_1: boolean;
    signal pending_interrupt_2: boolean;
    signal pending_interrupt_3: boolean;
    signal interrupt_vector_0: integer;
    signal interrupt_vector_1: integer;
    signal interrupt_vector_2: integer;
    signal interrupt_vector_3: integer;
    signal isr_address: integer;

begin

process (all) begin
    if pending_interrupt_0 then
        isr_address <= interrupt_vector_0;
    elsif pending_interrupt_1 then
        isr_address <= interrupt_vector_1;
    elsif pending_interrupt_2 then
        isr_address <= interrupt_vector_2;
    elsif pending_interrupt_3 then
        isr_address <= interrupt_vector_3;
    end if;
end process;

end;


architecture better_example of avoid_numerals_in_names is
    signal pending_interrupts: boolean_vector(0 to 3);
    signal isr_address: integer;
    signal interrupt_vectors: integer_vector(0 to 3);
begin

process (all) begin
    for i in pending_interrupts'range loop
        if pending_interrupts(i) then
            isr_address <= interrupt_vectors(i);
        end if;
    end loop;
end process;

end;