package excessive_end_of_block_comments_pkg is
    type matrix_type is array (natural range <>, natural range <>) of bit;
end;

package body excessive_end_of_block_comments_pkg is
    function shift_left(matrix: matrix_type; shift_amount: natural) return matrix_type is
        variable shifted_matrix: matrix_type(matrix'range(1), matrix'range(2));
        constant NONZERO_COLUMNS_COUNT: natural := matrix'length(2) - shift_amount + 1;
    begin
        -- for each matrix row
        for i in matrix'range(1) loop
            -- for each matrix column
            for j in matrix'range(2) loop
                -- copy element or fill it with zero
                if j < NONZERO_COLUMNS_COUNT then
                    shifted_matrix(i, j) := matrix(i, j + shift_amount);
                else -- j >= NONZERO_COLUMNS_COUNT
                    shifted_matrix(i, j) := '0';
                end if; -- copy element or fill it with zero
            end loop; -- for each matrix column
        end loop; -- for each matrix row

        return shifted_matrix;
    end; -- function shift_left
end;