--------------------------------------------------------------------------------
-- Library and use clauses                                                    --
--------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

--------------------------------------------------------------------------------
-- Entity declaration                                                         --
--------------------------------------------------------------------------------
entity synchronous_ram is
    ----------------------------------------------------------------------------
    -- Generics declaration                                                   --
    ----------------------------------------------------------------------------
    generic (
        RAM_DEPTH: natural := 1024;
        DATA_WIDTH: natural := 32
    );
    ----------------------------------------------------------------------------
    -- Ports declaration                                                      --
    ----------------------------------------------------------------------------
    port (
        -- Input ports
        clock: in std_logic;
        reset: in std_logic;
        write_enable: in std_logic;
        address: in std_logic_vector;
        data_in: in std_logic_vector;
        -- Output ports
        data_out: in std_logic_vector
    );
end;

--------------------------------------------------------------------------------
-- Architecture declaration                                                   --
--------------------------------------------------------------------------------
architecture rtl of synchronous_ram is
    --...
begin
end;