library ieee;
use ieee.std_logic_1164.all;

entity comment_layout_example is
    port (
        clock: in std_logic;
        enable: in std_logic;
        load_data: in std_logic;
        data: out std_logic
    );
end;

architecture rtl of comment_layout_example is
begin

    -- This is a block comment. It spans multiple lines and describes the code that
    -- follows. All lines in a block comment should be indented at the level of the
    -- first line of code underneath it.
    process (clock) is
        variable minimum_value: integer;    -- This is an endline comment for a data declaration
        variable maximum_value: integer;    -- Another endline comment for a data declaration
    begin
        if rising_edge(clock) then
            -- This is a full-line comment. Prefer this style to endline comments.
            if enable then
                data <= load_data;  -- An endline comment describing a statement. This should be avoided.
            end if;
        end if;
    end process;

end;