use work.function_header_example_pkg.all;

package body function_header_example_pkg is

    --------------------------------------------------------------------------------
    -- Function name:   rectangle_contains_point
    --
    -- Purpose:         Check if the given point coordinates are within the limits
    --                  determined by the given rectangle.
    --
    -- Algorithm:       If the point's x coordinate is within the rectangle's
    --                  left and right edges, and the point's y coordinate is
    --                  between the top and bottom edges, than the point is
    --                  contained within the rectangle.
    --
    -- Inputs:          rectangle     The rectangle
    --                  point         The point
    --
    -- Return value:    True if the point is contained within the rectangle,
    --                  False if the point is outside the rectangle.
    --
    -- Author:          Jim Hacker
    --
    -- Creation date:   06/01/2014
    --
    -- Modifications:   none
    --------------------------------------------------------------------------------
    function rectangle_contains_point(rectangle: rectangle_type; point: point_type)
        return boolean is
    begin
        return (
            (point.x >= rectangle.left) and (point.x <= rectangle.right) and
            (point.y >= rectangle.top) and (point.y <= rectangle.bottom)
        );
    end;

end;
