library ieee;
use ieee.fixed_float_types.all;
use ieee.float_pkg.all;

package endline_comments_example_pkg is
    -- Generic function for subtracting two floating point numbers. The function is
    -- flexible enough to be used with any rounding style, a configurable number of
    -- guard bits, and with or without support for subnormal numbers.
    function subtract(
        minuend: unresolved_float;                          -- Left operand
        subtrahend: unresolved_float;                       -- Right operand
        constant ROUND_STYLE: round_type := round_nearest;  -- Rounding style
        constant GUARD: natural := 3;                       -- Number of guard bits
        constant DENORMALIZE: boolean := true               -- Turn on subnormal number
                                                            --   processing
    ) return unresolved_float;
end;
