library ieee;
use ieee.std_logic_1164.all;

entity dff_examples is
    port(
        clock: in std_ulogic;
        reset: in std_ulogic;
        d: in  std_ulogic;
        q: out std_ulogic
    );
end;

architecture with_sensitivity_list of dff_examples is
begin
    process (clock) begin
        if rising_edge(clock) then
            q <= d;
        end if;
    end process;
end;

architecture with_wait_statement of dff_examples is
begin
    process begin
        wait until rising_edge(clock);
        q <= d;
    end process;
end;

architecture with_async_reset of dff_examples is
begin
    process (clock, reset) begin
        if reset then
            q <= '0';
        elsif rising_edge(clock) then
            q <= d;
        end if;
    end process;
end;

architecture with_sync_reset of dff_examples is
begin
    process (clock, reset) begin
        if reset then
            q <= '0';
        elsif rising_edge(clock) then
            q <= d;
        end if;
    end process;
end;