library ieee;
use ieee.std_logic_1164.all;

entity register_inference_example is
    port (
        clock: in std_ulogic;
        condition: in std_ulogic;
        a, b: in std_ulogic;
        y: out std_ulogic
    );
end;

architecture rtl of register_inference_example is
begin

    process (clock)
        variable auxiliary_value: std_ulogic := '0';
    begin
        if rising_edge(clock) then
            if condition then
                auxiliary_value := a xor b;
            end if;

            -- A register is inferred for variable 'auxiliary_value'
            -- because it is read before being assigned a value when
            -- 'condition' is false.
            y <= auxiliary_value;
        end if;
    end process;

end;