library ieee;
use ieee.std_logic_1164.all;

entity if_statement_unintentional_latch is
    port (
        d, condition: in std_ulogic;
        q1, q2, q3: out std_ulogic
    );
end;

architecture rtl of if_statement_unintentional_latch is
begin

    -- Latch inferred due to incomplete assignment
    process (all) begin
        if condition then
            q1 <= d;
        end if;
    end process;

    -- Latch prevented with an else clause
    process (all) begin
        if condition then
            q2 <= d;
        else
            q2 <= '0';
        end if;
    end process;

    -- Latch prevented by a default, unconditional assignment
    process (all) begin
        q3 <= '0';
        if condition then
            q3 <= d;
        end if;
    end process;

end;
