library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity sync_rom_array is
    port (
        clock: in std_ulogic;
        address: in unsigned(3 downto 0);
        data_out: out unsigned(7 downto 0)
    );
end;

architecture rtl of sync_rom_array is
    signal data_out_int: natural range 0 to 255;
    type rom_contents_type is array (natural range <>) of integer range 0 to 255;
    constant rom_contents: rom_contents_type := (
         13,  37,  62,  86, 109, 131, 152, 171,
        189, 205, 219, 231, 240, 247, 252, 255
    );
begin
    data_out <= to_unsigned(data_out_int, data_out'length);

    process (clock) begin
        if rising_edge(clock) then
            data_out_int <= rom_contents(to_integer(address));
        end if;
    end process;
end;