library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity sync_rom_case is
    port (
        clock: in std_ulogic;
        address: in unsigned(3 downto 0);
        data_out: out unsigned(7 downto 0)
    );
end;

architecture rtl of sync_rom_case is
    signal address_int: natural range 0 to 15;
    signal data_out_int: natural range 0 to 255;
begin
    
    address_int <= to_integer(unsigned(address));
    data_out <= unsigned(to_unsigned(data_out_int,8));
    
    process (clock) begin
        if rising_edge(clock) then
            case address_int is
                when 0 =>  data_out_int <=  13;
                when 1 =>  data_out_int <=  37;
                when 2 =>  data_out_int <=  62;
                when 3 =>  data_out_int <=  86;
                when 4 =>  data_out_int <= 109;
                when 5 =>  data_out_int <= 131;
                when 6 =>  data_out_int <= 152;
                when 7 =>  data_out_int <= 171;
                when 8 =>  data_out_int <= 189;
                when 9 =>  data_out_int <= 205;
                when 10 => data_out_int <= 219;
                when 11 => data_out_int <= 231;
                when 12 => data_out_int <= 240;
                when 13 => data_out_int <= 247;
                when 14 => data_out_int <= 252;
                when 15 => data_out_int <= 255;
            end case;
        end if;
    end process;
end;