library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity hash_calculator is
    port (
        message: in string(1 to 32);
        hash: out std_logic_vector(31 downto 0)
    );
end;

architecture rtl of hash_calculator is
begin
    process (message)
        variable h: std_logic_vector(31 downto 0);
        variable msg_byte: std_logic_vector(7 downto 0);
    begin
        h := (others => '0');
        for i in message'range loop
            msg_byte := std_logic_vector(to_unsigned(character'pos(message(i)), 8));
            h := (h rol 4) xor 24x"0" & msg_byte;
        end loop;
        hash <= h;
    end process;
end;
